//
//  webRtcManager+StatisticsReport.m
//  双子星云手机
//
//  Created by xd h on 2024/9/10.
//

#import "webRtcManager+StatisticsReport.h"

@implementation webRtcManager (StatisticsReport)
// IsChannel:是否是P2P通道
- (void)reportWebRtcRePoportTypeIsChannel:(BOOL)IsChannel withStats:(RTC_OBJC_TYPE(RTCStatisticsReport) *)stats
{
    if(!stats){
        [self reportWebRtcRePoportTypeIsChannel:IsChannel withStatus:0];
        return;
    }
    
    NSDictionary *remoteCandidateDict = nil;
    NSDictionary *localCandidateDict = nil;
    for (NSString *key in [stats.statistics allKeys]) {
        RTCStatistics *rtcStatistics = [stats.statistics objectForKey:key];
        //HLog(@"%@",rtcStatistics)
        
        if ([rtcStatistics.type isEqualToString:@"remote-candidate"]) {
            remoteCandidateDict = rtcStatistics.values;
            continue;
        }
        
        if ([rtcStatistics.type isEqualToString:@"local-candidate"]) {
            localCandidateDict = rtcStatistics.values;
            continue;
        }
        
        if(localCandidateDict && remoteCandidateDict){
            break;
        }
    }
    
    if([[localCandidateDict allKeys] containsObject:@"candidateType"]
       &&[[remoteCandidateDict allKeys] containsObject:@"candidateType"]){
        NSString *localCandidateType = localCandidateDict[@"candidateType"];
        NSString *remoteCandidateType = remoteCandidateDict[@"candidateType"];
        
        if([localCandidateType isEqualToString:@"relay"]
           ||[remoteCandidateType isEqualToString:@"relay"]){
            [self reportWebRtcRePoportTypeIsChannel:IsChannel withStatus:2];
        }
        else{
            [self reportWebRtcRePoportTypeIsChannel:IsChannel withStatus:1];
        }
        
    }else{
        [self reportWebRtcRePoportTypeIsChannel:IsChannel withStatus:2];
    }
}

- (void)reportWebRtcRePoportTypeIsChannel:(BOOL)IsChannel withStatus:(int)linkState
{
    
    NSMutableDictionary *paraDict = [NSMutableDictionary new];
    [paraDict setValue:@2 forKey:@"type"];
    [paraDict setValue:[NSNumber numberWithInt:linkState] forKey:@"status"];
    int channelType = IsChannel ? 1 : 2;
    [paraDict setValue:[NSNumber numberWithInt:channelType] forKey:@"channelType"];
    int clientNetworkStatus = [pingManager shareManager].isPingOk ? 0 : 1;
    [paraDict setValue:[NSNumber numberWithInt:clientNetworkStatus] forKey:@"clientNetworkStatus"];
    
    [[netWorkManager shareInstance] CommonPostCallBackCode:webrctLogAdd Parameters:paraDict success:^(id  _Nonnull responseObject){
        
        SuperModel *curModel = [[SuperModel alloc] initWithDictionary:responseObject error:nil];
        if(curModel && curModel.status == 0){
            
        }
        else
        {
        }
        
    } failure:^(NSError * _Nonnull error) {
        HLog(@"")
    }];
}
@end
